open Sys
open Prank
open Util

let usage_text = "usage multiprank_classify [options] <test_file> <model_file> <output_file>
[options] are any of: 

"

let arg_error str = 
  Printf.fprintf stderr "%s\n" usage_text;
  failwith ("Error: " ^ str)

let l = Array.length argv
let _ = if l < 4 then arg_error "not enough arguments"
let test_file = open_in argv.(l-3)
let model_file = open_in_bin argv.(l-2)
let out_file = open_out argv.(l-1)

let model = (Marshal.from_channel model_file : model) 
let (data, num_categories) = parse_data_file ~multi:true test_file;;
  
match model with
  | Multi m_model -> if (m_model.num_categories <> num_categories) then
	failwith "model and data have differing number of categories!!"
  | _ -> failwith "Attempting to to load Single model in multi mode!!"
      
let mistakes = ref 0.
let distance = ref 0.

let _ = run_model model data out_file

							    

  

