
type alpha = (Util.instance, int) Hashtbl.t
type weights = float array
type kernel = int option
type history = (Util.instance * int) list
type model = {
  weights : weights;
  mutable bias : float option;
  avg_weights : weights;
  mutable avg_bias : float option;
  kernel : kernel;
  alpha : alpha;
  mutable history : history;
  avg : bool;
  mutable trained : bool;
}
val poly_kernel : Util.features -> Util.features -> int -> float
val get_score_straight : Util.instance -> model -> float
val get_score_poly_kernel : Util.instance -> model -> int -> float
val get_vote_poly_kernel : Util.instance -> model -> int -> float
val get_score : Util.instance -> model -> float
val predict : Util.instance -> model -> Util.label
val update_weights : model -> Util.instance -> unit
val update_alpha : model -> Util.instance -> unit
val update_with_prediction :
  ?mistakes:float ref -> model -> Util.instance -> int -> unit
val update : float ref -> model -> Util.instance -> unit
val finalize_model : model -> unit
val definalize_model : model -> unit
