val debug : bool
val counter : int ref
val aaa : int ref
val ada : int ref
val add : int ref
val ddd : int ref
val daa : int ref
val dad : int ref
val all_ranks_glob : int array array Global.t
type boundaries = float array
type weights = float array
type single_model = {
  w : weights;
  b : boundaries;
  w_sum : weights;
  b_sum : boundaries;
  mutable w_avg : weights;
  mutable b_avg : boundaries;
  w_hist : Util.features Util.Dray.t;
  b_hist : boundaries Util.Dray.t;
  hist_count : int ref Util.Dray.t;
  vote : bool;
  avg : bool;
  normalize : bool;
  normalize2 : bool;
  mutable trained : bool;
  updates : int ref;
  num_ranks : int;
  num_feats : int;
}
type meta_model = Dist of int | FoodAtmosDiv
type agreement_model = Perceptron.model
type multi_model = {
  models : single_model array;
  mutable multi_trained : bool;
  agree : agreement_model option;
  num_categories : int;
  num_updates : int ref;
  c_train : float list option;
  c_test : float list option;
  a_train : (int list * float) list list option;
  a_test : (int list * float) list list option;
  m_train : float array list option;
  m_test : float array list option;
  m_type : meta_model option;
  alpha : float;
  use_sim : bool;
  sim : (int * int, float) Util.H.t;
}
type model = Multi of multi_model | Single of single_model
val multi_of_single : single_model -> multi_model
val normalize : single_model -> unit
val normalize2 : single_model -> unit
val normalize3 : single_model -> unit
val get_rank : float -> boundaries -> int
val predict : Util.instance -> single_model -> int
val i_cost : int -> float array -> boundaries array -> float
val second_best : int -> float -> boundaries -> int * float
val rnk_dist_i : int array -> int -> bool
val dist : int array -> int array -> float
val dfn_rnk_vctrs : int -> int -> unit
val get_meta_grf : float array -> meta_model -> int array -> float
val get_rnk_grf : int -> float -> float array -> int -> float
val predict_meta :
  float array -> meta_model -> float array -> float array array -> int array
val predict_agree :
  (int list * float) list ->
  int array -> float array -> 'a -> float array array -> int array
val predict_concensus :
  float -> int array -> float array -> boundaries array -> int array
val get_scores_sim : Util.instance array -> multi_model -> float array
val predict_sim : Util.instance array -> multi_model -> int array
val predict_multi :
  ?a_scores:(int list * float) list option ->
  ?c_score:float option ->
  ?m_scores:float array option ->
  Util.instance array -> multi_model -> int array
val run_model :
  ?verbose:int -> model -> Util.instance list -> out_channel -> unit
